#ifndef SIMULATION_H
#define SIMULATION_H

#include <vector>
#include "behavior.h"
#include "team.h"

class MapScene;

class Simulation
{
private:
    Map *p_map;
    std::vector<Dude*> m_dudes;
    std::vector<Team> m_teams;
public:
    Simulation(Map *_map, std::vector<BehaviorFunction> &_behaviors);
    MapScene* getMap() { return (MapScene*) p_map; }

    /**
     * @brief update runs one step of simulation
     */
    void update();
    void handleAction(Action*, Dude* dude);
};

#endif // SIMULATION_H
